// JavaScript Document

String.prototype.capitalize = function()

{

    return this.charAt(0).toUpperCase() + this.slice(1);

}



var sortArr = function(array){
	var arrKeys = [];
	var retArr = []
	$.each(array, function(r,w){
		arrKeys.push(w.code);
	});
	$.each(arrKeys.sort(), function(i, il){
		$.each(array, function(a, ar){
			if(il==ar.code){
				retArr.push(ar)
			}
		})
	})
	
	return retArr;
}

var DrillUpManager = {
	top:''
}

var childParentMappings = { //maps layers to next relation layer
	down:{//parent to child
		country: "county",
		county : "constituency",
		constituency : "ward",
		ward : "pollingstation"
	},
	up:{//Child to parent
		county: "country",
		constituency : "county",
		ward : "constituency",
		pollingstation: "ward"
	}
}

var locationCodeNos = {
	"country": 1,
	"county":2,
	"constituency":3,
	"ward":4
}

var LOCATIONTYPES = {

	country:"county",

	county:"constituency",

	constituency:"ward",

	ward:"pollingstation"

};



var LOCATIONTYPES_REVERSE = {

	county:"country",

	constituency:"county",

	ward:"constituency",

	pollingstation:"ward"

};



var CONTESTOBJECT = {

	"1": "Presidential",

	"2": "Gubernatorial",

	"3": "Senatorial",

	"5": "Women Rep CAW",

	"4": "National Assembly Rep",

	"6": "C.A.W. Representative"

}



var election = {

	id:"",

	post:0,

	level: "",

	loc:""

};



var addCommas = function(nStr){

    nStr += '';

    var x = nStr.split('.');

    var x1 = x[0];

    var x2 = x.length > 1 ? '.' + x[1] : '';

    var rgx = /(\d+)(\d{3})/;

    while (rgx.test(x1)) {

        x1 = x1.replace(rgx, '$1' + ',' + '$2');

    }

    return x1 + x2;

}



var candidatePerc = function(votes){

	return votes.candidate/votes.valid*100;

}



var sortCandidates = function(array){

	var sortedList = array.sort(function(a, b){

		var canA = a.votes;

		var canB = b.votes;

		return (canB - canA);

	});

	return sortedList;

}



var token = "273041c475980571588a77437a385999";

var CURRENT_LOC;

var panelOpen;

var getElections = function(){//This function returns elections data received from the API and configures the gadget as per the election selected.
	var loadInstance = Math.random();
	var keyStr = {};
	var electionsTitleObj={};
    $.ajax({
		url: "http://latest-api.api-iebc.appspot.com/election/?&token="+token+"&key="+generateKey(keyStr),
		dataType: "json",
		beforeSend: function(){
			$('#election-selector-be, #election-selector-gek, #election-selector-re').html('');
			$('#election-page-loading').show(200);
		},
		error: function(){
			$('#election-page-loading').hide(200);
			alert("There was an error while fetching election information!")
		},
		success: function(json){
			$('#election-page-loading').hide(200);
			var available_elections = sortArr(json.elections);
			$('#goto-results li:last-child').hide(0);
			$.each(available_elections, function(e, Melection){
				if(Melection.type=="By-Election"){
					if(!electionsTitleObj[Melection.name]){
						electionsTitleObj[Melection.name] = $('<div id="collapse-for-'+Melection.name+'" data-role="collapsible" data-theme="d" data-content-theme="d" data-iconpos="right">\
							<h3>'+Melection.name+'</h3>\
							<ul id="election-selector-be-'+Melection.name+'-list" data-role="listview" class="ui-listview ui-li-has-arrow" data-inset="true" data-theme="d" data-filter="true"></ul>\
						</div>');
					}
					$.each(Melection.locations, function(be, bElection){
						electionsTitleObj[Melection.name].children("ul").append('<li class="ui-li ui-last-child"><a href="#win_results" elecID="'+Melection.code+'" elecPost="'+bElection.post+'" elecLevel="'+bElection.location+'" data-prefetch="true" data-transition="slide" elecLoc="'+bElection.locationID+'" class="election-href">'+bElection.name+'</a></li>');
					});
					$('#election-selector-be').append(electionsTitleObj[Melection.name]);
					$('#election-selector-be').find('ul').listview()
					$('#election-selector-be').collapsibleset("refresh");
				}
				else if(Melection.type=="General Election"){
					$('#election-selector-gek').append('<li class="ui-li"><a href="#win_results" elecID="'+Melection.code+'" elecPost="all" elecLevel="country" data-prefetch="true" data-transition="slide" elecLoc="KE" class="election-href">'+Melection.name+'</a></li>');
				}
				else{
					$('#election-selector-re').append('<li class="ui-li"><a href="#win_results" elecID="'+Melection.code+'" elecPost="all" elecLevel="country" data-prefetch="true" data-transition="slide" elecLoc="KE" class="election-href">'+Melection.name+'</a></li>');
					$('#election-selector-re').listview("refresh", true);
				}
			});
			$('#election-selector-re, #election-selector-gek').listview("refresh", true)
		}
	});
}

$(document).ready(function(){
	if(window.location.hash=="" || window.location.hash== undefined){
		window.location.hash="#win_election"
		getElections();
	}
	$('#posts-list').on('change', function(){
		election.post = $(this).children('option:selected').val()
		getResults();
	});

	$('#refresh-btn').click(function(){
		getResults();
	})
	
	$('#win_election').on('pagecreate',function(event){
		getElections();	
		election = {};
		$('#results-view .results, #results-view #res-reporting, #results-view #res-valid, #results-view #res-turnout, #results-view #res-disputed, #results-view #res-rejected').empty();
	});
		
	$('#win_results').on('pageshow', function(){
		if(!CURRENT_LOC){
			$.mobile.changePage('#win_election', {transition: "pop"});
		}

	});

	$('.select-list').change(function(){

		var selected = $(this).children('option:selected');

		var selID = $(this).attr("id");
		CURRENT_LOC = {

			type : selID.split("-")[0],

			code : selected.val()

		}
		DrillUpManager[selID.split("-")[0]] = CURRENT_LOC;
		if(selID.split("-")[0]!="pollingstation"){
			getResults();
		}
		
		if(CURRENT_LOC.type!=DrillUpManager.top.type){
			$('#goto-results li:last-child').slideDown(100);
		}
		
		if(selID.split("-")[0]=="ward"){
			getPollingStations();
		}
		else if(selID.split("-")[0]=="pollingstation"){
			getPollingStationResults();
		}

		else

		{
			getLocation();
		}

	});
	$('div[id*="election-selector"], ul[id*="election-selector"]').on('click', 'li a',function(){
		election.post = $(this).attr("elecPost");
		election.id = $(this).attr("elecID");
		election.level = $(this).attr("elecLevel");
		election.loc = $(this).attr("elecLoc");

		CURRENT_LOC = {

			type: election.level,

			code: election.loc

		}
		DrillUpManager.top = CURRENT_LOC;
		$('#posts-list').html('<option data-placeholder="true">Select Post</option>');
		if(election.post=="all"){
			var availableposts = [1,2,3,4,5,6];
			console.log("This is all")
		}
		else{
			var availableposts = [election.post];
			console.log("This is "+election.post)
		}
		$.each(availableposts, function(ap, apost){
			if(availableposts.length == 1){
				$('#posts-list').append('<option value="'+apost+'" selected>'+CONTESTOBJECT[apost]+'</option>');
			}
			else{
				if(ap==0){
					$('#posts-list').append('<option value="'+apost+'" selected>'+CONTESTOBJECT[apost]+'</option>');
				}
				else{
					$('#posts-list').append('<option value="'+apost+'">'+CONTESTOBJECT[apost]+'</option>');
				}
			}
			
		});
		$('.select-list-container').hide(0);
		$('#win_results').on('pageshow', function(){
			if(CURRENT_LOC.type!="pollingstation"){
				getResults();
				if(CURRENT_LOC.type!="ward"){
					getLocation();
				}
				else{
					getPollingStations();
				}
			}
			$('#posts-list').selectmenu("refresh", true);
		});
	});

	$(document).bind("swiperight", function(){
		if(panelOpen){
			panelOpen.panel("close");
			panelOpen = false;
		}
	});

	$(document).bind("swipeleft", function(){
		panelOpen = $('#panel');
		panelOpen.panel("open");
	});
	
	$('#goto-results li:first-child').click(function(){
		if(panelOpen){
			panelOpen.panel("close");
			panelOpen = false;
		}
	});
	
	$('#goto-results li:last-child').click(function(){
		var upLevel = LOCATIONTYPES_REVERSE[CURRENT_LOC.type];
		if(upLevel!=DrillUpManager.top.type){
			$('#'+CURRENT_LOC.type+"-select-container").hide(30);
			CURRENT_LOC=DrillUpManager[upLevel];
			getResults();
		}
		else{
			CURRENT_LOC=DrillUpManager.top;
			getResults();
			$(this).hide(0);
		}
	});

	$('.list-elections').click(function(){

		if(panelOpen){

			if(panelOpen != $('#panel')){

				panelOpen.panel("close");

				panelOpen = $('#panel');

				panelOpen.panel("open");

			}

			else{

				panelOpen.panel("close");

			}

		}

		else{

			panelOpen = $('#panel');

			panelOpen.panel("open");

		}

	});

	

	contentFullHeight();

	

	var getPollingStations = function(){
		var keyStr = {};
		keyStr[CURRENT_LOC.type] = CURRENT_LOC.code;
		$.ajax({

			url: "http://latest-api.api-iebc.appspot.com/"+LOCATIONTYPES[CURRENT_LOC.type]+"/?"+CURRENT_LOC.type+"="+CURRENT_LOC.code+"&token="+token+"&key="+generateKey(keyStr),
			async:true,

			dataType: "json",

			success: function(json){

				var psList = json.polling_stations;

				$('#pollingstation-list').show(500).html("<option data-placeholder='true'>Select Polling Station...</option>");

				$('#pollingstation-select-container').show(500)

				$.each(psList, function(pID, prow){

					$('#pollingstation-list').append("<option value='"+prow.code+"'>"+prow.name+"</option>");

				});

				$('#pollingstation-list').selectmenu("refresh", true);

			}

		});

	}

	

	var getLocation = function(){
		var keyStr = {}
		keyStr[CURRENT_LOC.type]=CURRENT_LOC.code;
		if(CURRENT_LOC.type != "country"){

			var url = "http://latest-api.api-iebc.appspot.com/"+LOCATIONTYPES[CURRENT_LOC.type]+"/?"+CURRENT_LOC.type+"="+CURRENT_LOC.code+"&token="+token+"&key="+generateKey(keyStr);

		}

		else{

			var url = "http://latest-api.api-iebc.appspot.com/county/?token="+token+"&key="+generateKey({})

		}

		$.ajax({

			url:url,

			dataType:"json",

			beforeSend: function(){

			},

			success: function(json){

				if(json.status=="SUCCESS"){

					var locations = json.region.locations;

					var currLocType = json.region.location_type;

					var locType = LOCATIONTYPES[CURRENT_LOC.type];

					var selectID = '#'+locType+'-list';

					var $select = $(selectID);

					$('#'+locType+'-select-container').show(500);
					$('#'+childParentMappings.down[locType]+'-select-container').hide(500);
					$('#'+childParentMappings.down[childParentMappings.down[locType]]+'-select-container').hide(500);
					$select.empty();

					$select.append('<option data-placeholder="true">Choose '+LOCATIONTYPES[CURRENT_LOC.type].capitalize()+'</option>');

					$.each(locations, function(loc, location){

						$select.append('<option value="'+location.code+'">'+location.name+'</option>');

					});
				}

				else{

					alert("Error loading locations. Please try again.");

				}

				$select.selectmenu("refresh", true);

			}

		});

	}

	var pollingStationresultsView = function(json){
				var ps_results = json.results;
				if(ps_results.length > 0){
					$.each(ps_results, function(psr, ps_result){
						var thisRes = ps_result.results;
						var validVotes = 0;
						var listLI ="";
						var rejected = ps_result.rejected;
						var disputed = ps_result.disputed;
						$('#results-view .title').text(json.name+' Polling Station').addClass('header');
						$.each(thisRes, function(c, can){
							validVotes += parseInt(can.votes);
						});
						
						$('#results-view #res-valid').html("<div class='location-result-card'><div class='left'>Valid Votes Cast </div><div class='right'> "+addCommas(validVotes)+"</div>");

						$('#results-view #res-rejected').html("<div class='location-result-card'><div class='left'>Rejected Votes </div><div class='right'>"+addCommas(rejected)+"</div>");

						$('#results-view #res-disputed').html("<div class='location-result-card'><div class='left'>Disputed </div><div class='right'> "+addCommas(disputed)+"</div>");
							
						$.each(sortCandidates(thisRes), function(cr, canres){

							var canParty = $.trim(canres.party.abr);

							var partyPic = canres.party.symbol;

							if(!partyPic){

								partyPic = "http://latest-api.api-iebc.appspot.com/images/parties/"+canres.code+".jpg"

							}

							if(!canParty){

								canParty = "Independent";
								partyPic = "http://latest-api.api-iebc.appspot.com/images/parties/NOPIC.jpg";

							}

							var candPerc = candidatePerc({

								candidate: canres.votes,

								valid: validVotes

							});

							listLI += '<div class="result-row">\
								<div class="can-img"><img src="'+canres.picture+'"/></div>\
								<div class="party-img"><img src="'+partyPic+'"/></div>\
								<div class="candidate-info">\
									<div class="candidate-name">'+canres.name+'</div>\
									<div class="myPerc" style="background-color:'+canres.party.color+'; width:'+candPerc+'%"><div class="myPerc-no">'+candPerc.toFixed(1)+'%</div></div>\
									<div class="results-info">\
										<div class="party-info" style="color:#222>'+canParty+'</div>\
										<div class="results-no">'+addCommas(canres.votes)+' <span style="font-weight:100; color:#333">Votes</span></div>\
									</div>\
								</div>\
							</div>';	
						});
						$('#results-view .results').append(listLI);
					});

				}

				else{

					$('#results-view .results').html("No Results in Yet");

				}
	}

	var getPollingStationResults = function(){
		var ePost = election.post;
		var keyStr = {};
		keyStr["post"]=ePost;
		keyStr["election"]=election.id;
		$.ajax({
			url: "http://latest-api.api-iebc.appspot.com/results/pollingstation/"+CURRENT_LOC.code+"/?&post="+ePost+"&token="+token+"&election="+election.id+"&key="+generateKey(keyStr),
			async:true,
			dataType: "json",
			beforeSend: function(){
				$('#results-view .results, #results-view #res-reporting, #results-view #res-valid, #results-view #res-turnout, #results-view #res-disputed, #results-view #res-rejected').empty();
			},
			success: function(json){
				pollingStationresultsView(json);
			}
		});

	}

	

	var getResults = function(){

		var ePost = election.post;

		if(election.post=="all"){

			ePost = 1;

			if(CURRENT_LOC.type=="county" || CURRENT_LOC.type=="constituency" || CURRENT_LOC.type=="ward" || CURRENT_LOC.type=="pollingstation"){
			}

		}

		if(!CURRENT_LOC.code && !ePost){

			window.location="#win_election";

		}
		var keyStr = {};
		keyStr["post"]=ePost;
		keyStr["election"]=election.id;
		$.ajax({

			url:"http://latest-api.api-iebc.appspot.com/results/"+CURRENT_LOC.type+"/"+CURRENT_LOC.code+"/?token="+token+"&election="+election.id+"&post="+ePost+"&key="+generateKey(keyStr),

			dataType:"json",

			beforeSend: function(){
				$('#results-view .results, #results-view #res-reporting, #results-view #res-valid, #results-view #res-turnout, #results-view #res-disputed, #results-view #res-rejected, #results-view .title').empty();
				$('#results-page-loading').show(200);
			},

			success: function(json){

				if(json.status=="SUCCESS"){
					$('#results-page-loading').hide(500);
					var contests = json.contests;
					console.log(CURRENT_LOC);
					if(CURRENT_LOC.type!="pollingstation"){
						if(contests[0].locations!=undefined){
							var results = contests[0].locations[0].results;
							var locName = contests[0].locations[0].location;
							var rejected = contests[0].locations[0].rejected;
							var disputed = contests[0].locations[0].disputed;
							var turnout = contests[0].locations[0].turnout;
							var validV = contests[0].locations[0].valid;
							var reportingPS = contests[0].locations[0].reporting_ps
							if(CURRENT_LOC.type.capitalize()!="Country"){
								$('#results-view .title').text('Provisional Results For '+locName+' '+CURRENT_LOC.type.capitalize()).addClass('header');
							}
							else{
								$('#results-view .title').text('Provisional Results For '+locName).addClass('header');
							}
	
							$('#results-view #res-reporting').html("<div class='location-result-card'><div class='left'>Reporting Polling Cnts </div><div class='right'>"+reportingPS.ps_reporting+" / "+reportingPS.ps_location_total+"</div>");
	
							$('#results-view #res-valid').html("<div class='location-result-card'><div class='left'>Valid Votes Cast </div><div class='right'> "+addCommas(contests[0].locations[0].valid)+"</div>");
	
							$('#results-view #res-rejected').html("<div class='location-result-card'><div class='left'>Rejected Votes </div><div class='right'>"+addCommas(rejected)+"</div>");
	
							$('#results-view #res-turnout').html("<div class='location-result-card'><div class='left'>Turnout </div><div class='right'> "+addCommas(turnout.toFixed(2))+" %</div>");
	
							$('#results-view #res-disputed').html("<div class='location-result-card'><div class='left'>Disputed </div><div class='right'> "+addCommas(disputed)+"</div>");
							
							var listLI ="";
	
							$.each(sortCandidates(results), function(res, result){
	
								var canParty = $.trim(result.party.abr);
	
								var partyPic = result.party.symbol;
	
								if(!partyPic){
	
									partyPic = "http://latest-api.api-iebc.appspot.com/images/parties/"+result.code+".jpg"
	
								}
	
								if(!canParty){
	
									canParty = "Independent";
									partyPic = "http://latest-api.api-iebc.appspot.com/images/parties/NOPIC.jpg";
								}
	
								var candPerc = candidatePerc({
	
									candidate: result.votes,
	
									valid: validV
	
								});
	
								listLI += '<div class="result-row">\
										<div class="can-img"><img src="'+result.picture+'"/></div>\
										<div class="party-img"><img src="'+partyPic+'"/></div>\
										<div class="candidate-info">\
											<div class="candidate-name">'+result.name+'</div>\
											<div class="myPerc" style="background-color:'+result.party.color+'; width:'+candPerc+'%"><div class="myPerc-no">'+candPerc.toFixed(1)+'%</div></div>\
											<div class="results-info">\
												<div class="party-info" style="color:#222">'+canParty+'</div>\
												<div class="results-no">'+addCommas(result.votes)+' <span style="font-weight:100; color:#333">Votes</span></div>\
											</div>\
										</div>\
									</div>';				
	
							});
	
							$('#results-view .results').html(listLI);
	
						}
	
						else{
							if(ePost==1){
								$('#results-view .title').text("Results not yet in!").addClass('header');
								$('#results-view .results').html("<div style='font-size:13px; font-weight:700; text-align:center; padding:15px;'>No Results in Yet!</div>");
							}
							else if(ePost==2 || ePost==3 || ePost==5){
								if(locationCodeNos[CURRENT_LOC.type]>= 2){
									$('#results-view .title').text("Results not yet in!").addClass('header');
									$('#results-view .results').html("<div style='font-size:13px; font-weight:700; text-align:center; padding:15px;'>No Results in Yet!</div>");
								}
								else{
									$('#results-view .title').text("Selection Required!").addClass('header');
									$('#results-view .results').html("<div style='font-size:13px; font-weight:700; text-align:center; padding:15px;'>Please select a county!</div>");
								}
							}
							else if(ePost==4){
								if(locationCodeNos[CURRENT_LOC.type]>= 3){
									$('#results-view .title').text("Results not yet in!").addClass('header');
									$('#results-view .results').html("<div style='font-size:13px; font-weight:700; text-align:center; padding:15px;'>No Results in Yet!</div>");
								}
								else{
									$('#results-view .title').text("Selection Required!").addClass('header');
									$('#results-view .results').html("<div style='font-size:13px; font-weight:700; text-align:center; padding:15px;'>Please select a constituency!</div>");
								}
							}
							else if(ePost==6){
								if(locationCodeNos[CURRENT_LOC.type]== 4){
									$('#results-view .title').text("Results not yet in!").addClass('header');
									$('#results-view .results').html("<div style='font-size:13px; font-weight:700; text-align:center; padding:15px;'>No Results in Yet!</div>");
								}
								else{
									$('#results-view .title').text("Selection Required!").addClass('header');
									$('#results-view .results').html("<div style='font-size:13px; font-weight:700; text-align:center; padding:15px;'>Please select a ward!</div>");
								}
							}
						}
					}
					else{
						pollingStationresultsView(json);
					}
				}

				else{

					alert("Error loading results. Please try again.");

				}

			}

		});

	}

})



$(window).resize(function(){

	contentFullHeight();

});



var contentFullHeight = function(){

	$('[data-role="page"]').each(function(i, elem){

		if($(this).attr('id')!="win_about"){

			var $thisHeader = $(this).find('.header[data-role="header"]');

			var $thisFooter = $(this).find('.footer[data-role="footer"]');

			var $thisContent = $(this).find('.content[data-role="content"]');

			var negHeight = ($thisHeader.outerHeight()+$thisFooter.outerHeight());

			$thisContent.css({

				"min-height":($(window).height()- negHeight-30)+"px"

			});

		}

	});

}

var generateKey = function(message){
	var sortedFilters = sortObject(message);
	var keyStr="";
	$.each(sortedFilters, function(sF, sortedF){
		keyStr+=sF+"="+sortedF;
	});
	keyStr+="token=273041c475980571588a77437a385999";
	return CryptoJS.HmacSHA256(keyStr, "273041c475980571588a77437a3855b6");
}

function sortObject(o) {
    var sorted = {},
    key, a = [];

    for (key in o) {
        if (o.hasOwnProperty(key)) {
                a.push(key);
        }
    }

    a.sort();

    for (key = 0; key < a.length; key++) {
        sorted[a[key]] = o[a[key]];
    }
    return sorted;
}